<template>
  <div>
    <button class="btn btn-primary capsule" @click="showModal()">
      New
      <i class="fas fa-plus"></i>
    </button>
    <b-modal
      id="modal1"
      hide-footer
      hide-header
      centered
      ref="thisModal"
      class="border-0"
      size="600"
    >
      <div class="container">
        <div class="row mb-2">
          <div class="col-md-6">
            <h5>Create General Value</h5>
          </div>
          <div class="col-md-6">
            <img
              :src="asset(`images/ui_elements/ic_close.png`)"
              style="width:25px"
              @click="hideModal"
              class="float-right"
            >
          </div>
        </div>
        <div class="row">
          <div class="col-md-12">
            <form class="form-material" @submit.prevent="submitForm">
              <div class="form-group">
                <label>Key</label>
                <input
                  type="text"
                  class="form-control"
                  name="key"
                  v-validate="'required'"
                  placeholder="Enter Key"
                  v-model="form.key"
                >
                <small class="text-danger">{{ errors.first('key') }}</small>
              </div>
              <div class="form-group">
                <label>Value Type</label>
                <select class="form-control" v-model="form.valueType">
                  <option value="text">Text</option>
                  <option value="html">Html</option>
                </select>
              </div>
              <div class="form-group" v-show="form.valueType == 'text'">
                <label>Value</label>
                <input
                  type="text"
                  class="form-control"
                  name="value"
                  placeholder="Enter Value"
                  v-model="form.value"
                >
              </div>

              <div class="form-group" v-show="form.valueType == 'html'">
                <label>Value</label>
                <rich-editor v-model="form.value"></rich-editor>
              </div>

              <div class="form-group">
                <label>Description</label>
                <textarea v-model="form.description" name="description" class="form-control"></textarea>
              </div>

              <button type="submit" class="btn btn-primary form-control capsule">
                <span v-if="loading">
                  Saving
                  <i class="fas fa-circle-notch fa-spin"></i>
                </span>
                <span v-else>Save</span>
              </button>
            </form>
          </div>
        </div>
      </div>
    </b-modal>
  </div>
</template>
<script>
import EventBus from "@/EventBus.js";
import * as httpHelper from "@/helpers/httpHelper";
import RichEditor from "@/components/general/RichEditor";

export default {
  components: { RichEditor },
  data() {
    return {
      loading: false,
      form: {
        key: null,
        value: null,
        valueType: "text",
        description: null
      }
    };
  },
  watch: {
    "form.value_type"() {
      this.form.value = null;
    }
  },
  methods: {
    hideModal() {
      this.$refs.thisModal.hide();
    },
    showModal() {
      this.resetForm();
      this.$emit("show");
      this.$refs.thisModal.show();
    },
    resetForm() {
      this.form.key = this.form.description = this.form.value = null;
    },
    async submitForm() {
      let validated = await this.$validator.validateAll();

      if (validated) {
        try {
          this.loading = true;
          let response = await this.$axios.post(
            process.env.MIX_APP_URL +
              `/api/${this.$store.getters.appId.hashed}/general-value`,
            { ...this.form }
          );

          this.hideModal();
          httpHelper.successToast(this, response.data.message);
          EventBus.$emit("refreshTable");
        } catch (error) {
          httpHelper.errorToast(this, error);
        }
      } else {
        // this.$refs.lennaModal.show('alert','Sorry','You must correct your form first')
      }
      this.loading = false;
    }
  }
};
</script>
<style lang="scss" scoped>
.nav-link.active {
  background: #dadada !important;
  color: #1d68a7;
}
.tab-form {
  word-wrap: break-word;
}
.image-container {
  background: #e8e8e8;
  max-height: 400px;
  & input {
    opacity: 0 !important;
    height: 100%;
    position: absolute;
    top: 0;
  }
  & img {
    max-height: 250px;
  }
}
</style>